<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task32.55 update user form</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> 
</head>
<body>
    <div class = "container jumbotron">
        <div class = "text-center mb-4">
            <h3>Chi tiết user</h3>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>First Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-firstname" class = "form-control" placeholder="Nhập Firstname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Last Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-lastname" class = "form-control" placeholder="Nhập Lastname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Subject</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-subject" class = "form-control" placeholder="Nhập Subject...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Country</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-country" class = "form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Customer Type</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-customer-type" class = "form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Register Status</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-register-status" class = "form-control">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">

            </div>
            <div class = "col-sm-8">
                <button id = "btn-update-user" class = "btn btn-success w-25"> Update user</button>
                <button id = "btn-cancel" class = "btn btn-success w-25"> Hủy bỏ</button>
            </div>
        </div>
        
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện tải trang
    function onPageLoading(){
        "use strict";
        //thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //search param
        var vId = vUrl.searchParams.get("id");
        console.log("Id của user là: " + vId);
        callApiGetDataUserById(vId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiGetDataUserById(paramUserId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            dataType: "json",
            success: function (paramDataUserObj){
                console.log(paramDataUserObj);
                showDataUserToForm(paramDataUserObj);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });        
    }
    //hàm hiển thị dữ liệu lên form
    function showDataUserToForm(paramDataUserObj){
        "use strict";
        $("#input-firstname").val(paramDataUserObj.firstname);
        $("#input-lastname").val(paramDataUserObj.lastname);
        $("#select-country").val(paramDataUserObj.country);
        $("#input-subject").val(paramDataUserObj.subject);
        $("#select-customer-type").val(paramDataUserObj.customerType);
        $("#select-register-status").val(paramDataUserObj.registerStatus);
    }

</script>
</html>